#include <stdio.h>
#include <dlfcn.h>

int main(int argc, char **argv) {
	printf("Lazy loading of libextlib.so\n");
	// open the library
	void* handle = dlopen("./libextlib.so", RTLD_LAZY);
	if (!handle) {
		printf("Cannot open library: %s\n", dlerror());
		return 1;
	}
	// load the symbol
	printf("Loading symbol \"anyfunction\"\n");
	typedef void (*anyfunction_t)();
	// reset errors
	dlerror();
	anyfunction_t anyfunction = (anyfunction_t) dlsym(handle, "anyfunction");
	const char *dlsym_error = dlerror();
	if (dlsym_error) {
		printf("Cannot load symbol 'anyfunction': %s\n", dlsym_error);
		dlclose(handle);
		return 1;
	}

	// use it to do the calculation
	printf("Calling \"anyfunction\"\n");
	anyfunction();

	// close the library
	printf("Unload library libextlib.so\n");
	dlclose(handle);
	printf("Closing application\n");
}
